// Tableau recap notes
$(function () {
    $(function () {
        // Les boutons dépendent du mode BUT ou classique:
        let buttons = [
            {
                name: "toggle_ident",
                text: "Civ/Nom/Prénom",
                action: function (e, dt, node, config) {
                    let visible = dt.columns(".identite_detail").visible()[0];
                    dt.columns(".identite_detail").visible(!visible);
                    dt.columns(".identite_court").visible(visible);
                    dt.buttons('toggle_ident:name').text(visible ? "Civ/Nom/Prénom" : "Nom");
                }
            },
            {
                name: "toggle_partitions",
                text: "Toutes les partitions",
                action: function (e, dt, node, config) {
                    let visible = dt.columns(".partition_aux").visible()[0];
                    dt.columns(".partition_aux").visible(!visible);
                    dt.buttons('toggle_partitions:name').text(visible ? "Toutes les partitions" : "Cacher les partitions");
                }
            },
            $('table.table_recap').hasClass("apc") ?
                {
                    name: "toggle_res",
                    text: "Cacher les ressources",
                    action: function (e, dt, node, config) {
                        let visible = dt.columns(".col_res").visible()[0];
                        dt.columns(".col_res").visible(!visible);
                        dt.buttons('toggle_res:name').text(visible ? "Montrer les ressources" : "Cacher les ressources");
                    }
                } : {
                    name: "toggle_mod",
                    text: "Cacher les modules",
                    action: function (e, dt, node, config) {
                        let visible = dt.columns(".col_mod").visible()[0];
                        dt.columns(".col_mod").visible(!visible);
                        dt.buttons('toggle_mod:name').text(visible ? "Montrer les modules" : "Cacher les modules");
                    }
                }
        ];
        if ($('table.table_recap').hasClass("apc")) {
            buttons.push({
                name: "toggle_sae",
                text: "Cacher les SAÉs",
                action: function (e, dt, node, config) {
                    let visible = dt.columns(".col_sae").visible()[0];
                    dt.columns(".col_sae").visible(!visible);
                    dt.buttons('toggle_sae:name').text(visible ? "Montrer les SAÉs" : "Cacher les SAÉs");
                }
            })

        }
        buttons.push({
            name: "toggle_admission",
            text: "Montrer infos admission",
            action: function (e, dt, node, config) {
                let visible = dt.columns(".admission").visible()[0];
                dt.columns(".admission").visible(!visible);
                dt.buttons('toggle_admission:name').text(visible ? "Montrer infos admission" : "Cacher infos admission");
            }
        })
        $('table.table_recap').DataTable(
            {
                paging: false,
                searching: true,
                info: false,
                autoWidth: false,
                fixedHeader: {
                    header: true,
                    footer: false
                },
                orderCellsTop: true, // cellules ligne 1 pour tri 
                aaSorting: [], // Prevent initial sorting
                colReorder: true,
                "columnDefs": [
                    {
                        // cache le détail de l'identité et les colonnes admission
                        "targets": ["identite_detail", "partition_aux", "admission"],
                        "visible": false,
                    },
                ],
                dom: 'Bfrtip',
                buttons: ['copy', 'excel', 'pdf',
                    {
                        extend: 'collection',
                        text: 'Colonnes affichées',
                        autoClose: true,
                        buttons: buttons,
                    },
                ]
            }
        );

    });
    $('table.table_recap tbody').on('click', 'tr', function () {
        if ($(this).hasClass('selected')) {
            $(this).removeClass('selected');
        }
        else {
            $('table.table_recap tr.selected').removeClass('selected');
            $(this).addClass('selected');
        }
    });
});
